package it.unibo.tw0708.web.tags;

import java.io.IOException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspTagException;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.BodyTagSupport;

/**
 * Another servlet
 *
 * @author you
 */
public class SampleTagClass 
extends BodyTagSupport {
	
	// -----------------------------------------------------------
	// constants 
	// -----------------------------------------------------------
	
	private static final long serialVersionUID = 1L;

	// -----------------------------------------------------------
	// members 
	// -----------------------------------------------------------
	
	private String sampleAttribute;
	public void setSampleAttribute(String sampleAttribute) {
		mySystemOut("Setting...","sampleAttribute",sampleAttribute);
		this.sampleAttribute = sampleAttribute;
	}

	// -----------------------------------------------------------
	// init & relase methods (inherited and modified from super class) just to show how to handle them
	// -----------------------------------------------------------

    protected BodyContent bodyContent;
    public void setBodyContent(BodyContent bodyContent) {
		mySystemOut("Retrieving...","bodyContent",""+bodyContent);
        this.bodyContent = bodyContent;
    }
    public void release() {
        bodyContent = null;
		mySystemOut("Releasing...","bodyContent",""+this.bodyContent);
    }

	// -----------------------------------------------------------
    // tag processing methods...
	// -----------------------------------------------------------
    
    @SuppressWarnings("deprecation")
	public int doStartTag() throws JspException {
		mySystemOut("Evaluating start tag");
        return BodyTagSupport.EVAL_BODY_TAG;		// deprecated... now there are better ways to do that
    }
   
    // Default implementations for BodyTag methods as well
    // just in case a tag decides to implement BodyTag.
    public void doInitBody() throws JspException {
    	try { 
    	    mySystemOut("About to evaluate...", "sampleAttribute",this.sampleAttribute);
    		this.bodyContent.getEnclosingWriter().write("About to consume tag attribute char by char...<br/>");
    	}
    	catch (Exception e) {
    		System.out.println("Shit happens");
		}
    }

    @SuppressWarnings("deprecation")
    public int doAfterBody() throws JspException {
	    mySystemOut("Evaluating...", "sampleAttribute",this.sampleAttribute);
        try {
            if ( this.sampleAttribute.length() > 0 ) {
                bodyContent.getEnclosingWriter().write(this.sampleAttribute + "<br/>");
                this.sampleAttribute = this.sampleAttribute.substring(0,this.sampleAttribute.length()-1);
                return EVAL_BODY_TAG;
            } 
            else {
                return SKIP_BODY;
            }
        } catch (IOException ex) {
            throw new JspTagException(ex.toString());
        }
    }

    public int doEndTag() throws JspException {
	    mySystemOut("Evaluating end tag");
        return BodyTagSupport.EVAL_PAGE;
    }
	
	// -----------------------------------------------------------
    // helper stuff
	// -----------------------------------------------------------

    private void mySystemOut(String message) {
    	mySystemOut(message,null,null);
    }
    
    private void mySystemOut(String message, String name, String value) {
    	String out = "["+this.getClass().getSimpleName()+"] " + message;
    	if ( name != null ) 
    		out += " --> '" + name + "' = '" + value + "'";
    	System.out.println(out);
    }
}