<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<%@ page contentType="text/html; charset=US-ASCII" %>
<%@ page errorPage="../errorpages/failure.jsp"%>

<html>
<head>
	<meta name="Author" content="pisi79">
	<title>JSP that uses html code templates defined via tag libaries</title>
	<link rel="stylesheet" href="<%= request.getContextPath() %>/styles/default.css" type="text/css"/>
</head>

<body onload="document.getElementById('taghtml').style.backgroundColor='#aaa';">
<%@ include file="../fragments/menu" %>

<div id="main">

	<p> 
		The following is printed by using a template html code defined via a custom tag element.

		<jsp:useBean id="cart" class="it.unibo.tw0708.web.beans.Cart" scope="session">
		</jsp:useBean>
<%
		// Handling cart emptying 
		if ( request.getParameter("empty") != null )
			cart.empty();
%>

		<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %> 
		<%@ taglib uri="http://it.unibo.tw0708/tld/function" prefix="myfn" %> 
		<%@ taglib prefix="htmltags" tagdir="/WEB-INF/tags" %>

		<table border="1">
			<tr>
				<th>Item</th><th>Description</th><th>Orginal price</th><th>Discount</th><th>Discounted price</th>
			</tr>
			<c:forEach var="item" items="${cart.items}">
				<htmltags:cartRow 
					name="${item.name}" 
					description="${item.description}"
					originalprice="${item.price}"
					discount="${item.discount}"
					price="${myfn:discount(item.price,item.discount)}"
				/>
			</c:forEach>
		</table>
	</p>
	
	<htmltags:cartTable cart="${cart}">
		<jsp:attribute name="lastrow">
			<form action="taghtml.jsp" method="get">
				<input type="submit" value="empty cart" name="empty" style="width: 100%; background-color: #aaa;">
			</form>
		</jsp:attribute>
		<jsp:body>
	      	...and this is a different way and more powerful way to do that!
		</jsp:body>
	</htmltags:cartTable>
	
</div>

<%@ include file="../fragments/footer" %>
</body>
</html>
